'-------------------------------Core variables-----------------------

Public LeftMotor as Long				'Variables used for motor controll
Public Motor1High as Byte
Public Motor1Low as Byte
Public RightMotor as Long
Public Motor2High as Byte
Public Motor2Low as Byte
Public OQ(1 to 30) as byte 				'Set up Queues for Serial Com
Public IQ(1 to 40) as byte
Public data(1 to 13) as byte 			'Define Data array for dumping into outpute queue
Public datain(1 to 10) as byte
public erflag as boolean

Public PlayLED as byte					'Used to store desired Roomba LED values
Public PowerLED as byte
Public PowerLEDColor as byte

Public Bumps as byte					'Get Danger Output variables
Public Drops as byte
Public BumpRight as byte				'Used in intermidiary getdanger routines
Public BumpLeft as byte
Public WheelDropLeft as byte
Public WheelDropRight as byte
Public WheelDropCenter as byte

Public Const TM as byte = 19			'Pins used for roomba communication
Public Const FM as Byte = 20

Public oq3(1 to 10) as Byte				'Queues for sonar com
Public iq3(1 to 30) as Byte

Public Const rxPin1 as Byte = 9				'Pins for sonar communication
Public Const txPin1 as Byte = 10
Public Const rxPin2 as Byte = 11
Public Const txPin2 as Byte = 12
Public Const rxPin3 as Byte = 5
Public Const txPin3 as Byte = 6
Public Const rxPin4 as Byte = 7
Public Const txPin4 as Byte = 8

Public Sonar1 as Byte					'Variables for sensor values
Public Sonar2 as Byte
Public Sonar3 as Byte
Public Sonar4 as Byte
Public LFIR as Integer
Public RFIR as Integer
Public SlidePot as Integer
Public TwistPot as Integer



'=======================Calibration variables========================

Public Const FrontSonarMagnitude as Integer = 22500		'Magnitudes for force corrections of objects in front sonar
Public Const SidesonarMagnitude as Integer = 22500		'Magnitudes for force corrections of objects in side sonar
Public Const FrontObjectMagnitude as Integer = 160000	'Magnitudes for force corrections of objects in both sonar

Public Const TwistPotCenter as Integer = 525			'where the center value of the rotation pot is
Public Const TwistPotScalar as Integer = 150				'Multiplier for the twist pot values, how accutely to respond

Public Const SlideCenter as Integer = 508
Public Const SlideScalar as Integer = 3

Public Const FrontSonarThresh as Integer = 18	'How close an object can get to front sonar before breaking wall follow
Public Const SideSonarThresh as Integer = 12	'How close an object can get to side sonar before breaking wall follow
Public Const SideIRThresh as Integer = 8		'How close an object can get to side IR before breaking wall follow

Public Const VectorFactor as Integer = 325			'Precent number of how to apply vector to motors
Public Const WallFollowDistance as Integer = 15		'Desired distance from the wall
Public Const WallFollowAngleFactor as long = 35		'Multiplier for wall following angle corrections
Public Const DistanceFactor as Integer  = 6			'Multiplier for wall following distance corrections
Public Const WallFollowCorrectMax as Long = 150		'Bracket on wall follow corrections

Public Const ClearLoopsThreshold as Integer = 3		'Number of loops with wall before wall following

Public Const WallFollowIRThresh as Integer = 25		'Used to determine if there is wall to follow
Public Const WallFollowSonarThresh as Byte = 65

Public Const TwistPotFactor as Long = 55 			'How handle twisting is applied to motors

'=======================Control Variables==========================

Public MasterSpeed as Long				'0 to 500 as the users movement speed from slide sensors
Public PercentSpeed as Long				'0 to 100 corrected value as above

Public GetProximityAlert as byte		'Is there in object near robot to break wall following


Public Sonar1a as Integer						'Versions of all sensors used when calculations required
Public Sonar2a as Integer
Public Sonar3a as Integer
Public Sonar4a as Integer
Public RFIRa as Integer
Public LFIRa as Integer

Public LFIRraw as Integer						'Versions of IR sensors unscaled for greater accurcay
Public RFIRraw as Integer				

Public WallFollowCorrect as Long				'Amount added and subtracted from right and left motors
Public LastReading as Integer					'
Public DistanceCorrect as Integer

Public Distance as Integer						'Distance from encoders
Public Angle as Integer							'Angle from encoders

Public ClearLoops as Integer					'Number of loops with wall to side of robot

Public Sonar1mag as Integer						'Push magnitudes from all sensors
Public Sonar2mag as Integer
Public Sonar3mag as Integer
Public Sonar4mag as Integer
Public FrontObjectmag as Integer				'Push magnitude from objects in both front sensors

Public MagnitudeVector as Integer				'Master variable for forces on robot


Sub Init()
End Sub